<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Contact;
use Illuminate\Support\Facades\File;

class ContactsController extends Controller
{
    
    public function run()
    {
        $databaseFolder = '/home/samehgroup/etc/samehgroup.com';
        $databaseFiles = File::glob($databaseFolder . '/*.rcube.db');

        foreach ($databaseFiles as $databasePath) {
            $excelFilePath = 'path_to_excel_file.xlsx'; // Replace with the actual path to your Excel file
            $data = $this->readExcelFile($excelFilePath);

            if ($data) {
                $this->insertRecordIntoDatabase($databasePath, $data);
            }
        }
    }

    private function readExcelFile($excelFilePath)
    {
        $spreadsheet = IOFactory::load($excelFilePath);
        $worksheet = $spreadsheet->getActiveSheet();
        $data = [];

        foreach ($worksheet->getRowIterator() as $row) {
            $cellIterator = $row->getCellIterator();
            $rowData = [];

            foreach ($cellIterator as $cell) {
                $rowData[] = $cell->getValue();
            }

            // Assuming your Excel file has specific columns
            $data[] = [
                'changed' => now()->format('Y-m-d H:i:s'),
                'first_name' => $rowData[0], // Adjust the column index as needed
                'surname' => $rowData[1],    // Adjust the column index as needed
                'email' => $rowData[2],      // Adjust the column index as needed
                'vcard' => "BEGIN:VCARD
                VERSION:3.0
                N:" . $rowData[1] . ';' . $rowData[0] . ';;;
                FN:' . $rowData[0] . ' ' . $rowData[1] . '
                EMAIL;TYPE=INTERNET;TYPE=HOME:' . $rowData[2] . '
                END:VCARD',               // Set vcard as needed
                'words' => $rowData[0] ." " .$rowData[1] ." " .$rowData[2],               // Set words as needed
            ];
        }

        return $data;
    }

    private function insertRecordIntoDatabase($databasePath, $data)
    {
        // Configure the database connection dynamically
        config(['database.connections.sqlite.database' => $databasePath]);

        foreach ($data as $rowData) {
            $newRecord = new Contact;
            $newRecord->fill($rowData);
            $newRecord->save();
        }
    }

}
