<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Group extends Model
{
    use HasFactory;
    
    protected $table = 'contactgroups'; // Assuming your table name is 'contactgroups'
    protected $primaryKey = 'contactgroup_id';
    public $timestamps = false; // If you want to disable default created_at and updated_at timestamps
    
    
        // Define the data types for specific columns
    protected $casts = [
        'contactgroup_id' => 'integer',
        'changed' => 'datetime:Y-m-d H:i:s',
    ];
    
     public function contacts()
    {
        return $this->belongsToMany(Contact::class, 'contactgroupmembers', 'contactgroup_id', 'contact_id');
    }
}
